---
title: <length>
slug: Web/CSS/length
tags:
  - CSS
  - CSS Data Type
  - Data Type
  - Layout
  - Reference
  - Web
  - length
---
<div>{{CSSRef}}</div>

<p>The <strong><code>&lt;length&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> represents a distance value. Lengths can be used in numerous CSS properties, such as {{Cssxref("width")}}, {{Cssxref("height")}}, {{Cssxref("margin")}}, {{Cssxref("padding")}}, {{Cssxref("border-width")}}, {{Cssxref("font-size")}}, and {{Cssxref("text-shadow")}}.</p>

<div class="note">
<p><strong>Note:</strong> Although {{cssxref("&lt;percentage&gt;")}} values are also CSS dimensions, and are usable in some of the same properties that accept <code>&lt;length&gt;</code> values, they are not themselves <code>&lt;length&gt;</code> values. See {{cssxref("&lt;length-percentage&gt;")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<p>The <code>&lt;length&gt;</code> data type consists of a {{cssxref("&lt;number&gt;")}} followed by one of the units listed below. As with all CSS dimensions, there is no space between the unit literal and the number. The length unit is optional after the number <code>0</code>.</p>

<div class="note">
<p><strong>Note:</strong> Some properties allow negative <code>&lt;length&gt;</code>s, while others do not.</p>
</div>

<h3 id="Units">Units</h3>

<h4 id="Relative_length_units">Relative length units</h4>

<p>Relative lengths represent a measurement in terms of some other distance. Depending on the unit, this can be the size of a specific character, the <a href="/en-US/docs/Web/CSS/line-height">line height</a>, or the size of the {{glossary("viewport")}}.</p>

<h5 id="Font-relative_lengths">Font-relative lengths</h5>

<p>Font-relative lengths define the <code>&lt;length&gt;</code> value in terms of the size of a particular character or font attribute in the font currently in effect in an element or its parent.</p>

<div class="note">
<p><strong>Note:</strong> These units, especially <code>em</code> and <code>rem</code>, are often used to create scalable layouts, which maintain the <a href="https://24ways.org/2006/compose-to-a-vertical-rhythm">vertical rhythm of the page</a>  even when the user changes the font size.</p>
</div>

<dl>
 <dt><code id="cap">cap</code> {{experimental_inline}}</dt>
 <dd>Represents the "cap height" (nominal height of capital letters) of the element’s {{Cssxref("font")}}.</dd>
 <dt><code id="ch">ch</code></dt>
 <dd>Represents the width, or more precisely the advance measure, of the glyph "0" (zero, the Unicode character U+0030) in the element's {{Cssxref("font")}}.<br>
 <br>
 In the cases where it is impossible or impractical to determine the measure of the “0” glyph, it must be assumed to be 0.5em wide by 1em tall.</dd>
 <dt><code id="em">em</code></dt>
 <dd>Represents the calculated {{Cssxref("font-size")}} of the element. If used on the {{Cssxref("font-size")}} property itself, it represents the <em>inherited</em> font-size of the element.</dd>
 <dt><code id="ex">ex</code></dt>
 <dd>Represents the <a href="https://en.wikipedia.org/wiki/X-height">x-height</a> of the element's {{Cssxref("font")}}. On fonts with the "x" letter, this is generally the height of lowercase letters in the font; <code>1ex ≈ 0.5em</code> in many fonts.</dd>
 <dt><code id="ic">ic</code> {{experimental_inline}}</dt>
 <dd>Equal to the used advance measure of the "水" glyph (CJK water ideograph, U+6C34), found in the font used to render it.</dd>
 <dt><code id="lh">lh</code> {{experimental_inline}}</dt>
 <dd>Equal to the computed value of the {{Cssxref("line-height")}} property of the element on which it is used, converted to an absolute length.</dd>
 <dt><code id="rem">rem</code></dt>
 <dd>Represents the {{Cssxref("font-size")}} of the root element (typically {{HTMLElement("html")}}). When used within the root element {{Cssxref("font-size")}}, it represents its initial value (a common browser default is <code>16px</code>, but user-defined preferences may modify this).</dd>
 <dt><code id="rlh">rlh</code> {{experimental_inline}}</dt>
 <dd>Equal to the computed value of the {{Cssxref("line-height")}} property on the root element (typically {{HTMLElement("html")}}), converted to an absolute length. When used on the {{Cssxref("font-size")}} or {{Cssxref("line-height")}} properties of the root element, it refers to the properties' initial value.</dd>
</dl>

<h5 id="Viewport-percentage_lengths">Viewport-percentage lengths</h5>

<p>Viewport-percentage lengths define the <code>&lt;length&gt;</code> value relative to the size of the {{glossary("viewport")}}, i.e., the visible portion of the document. Viewport lengths are invalid in {{cssxref("@page")}} declaration blocks.</p>

<dl>
 <dt><code id="vh">vh</code></dt>
 <dd>Equal to 1% of the height of the viewport's initial <a href="/en-US/docs/Web/CSS/All_About_The_Containing_Block">containing block</a>.</dd>
 <dt><code id="vw">vw</code></dt>
 <dd>Equal to 1% of the width of the viewport's initial <a href="/en-US/docs/Web/CSS/All_About_The_Containing_Block">containing block</a>.</dd>
 <dt><code id="vi">vi</code> {{experimental_inline}}</dt>
 <dd>Equal to 1% of the size of the initial <a href="/en-US/docs/Web/CSS/All_About_The_Containing_Block">containing block</a>, in the direction of the root element’s <a href="/en-US/docs/Web/CSS/CSS_Logical_Properties#inline-dimension">inline axis</a>.</dd>
 <dt><code id="vb">vb</code> {{experimental_inline}}</dt>
 <dd>Equal to 1% of the size of the initial <a href="/en-US/docs/Web/CSS/All_About_The_Containing_Block">containing block</a>, in the direction of the root element’s <a href="/en-US/docs/Web/CSS/CSS_Logical_Properties#block-dimension">block axis</a>.</dd>
 <dt><code id="vmin">vmin</code></dt>
 <dd>Equal to the smaller of <code>vw</code> and <code>vh</code>.</dd>
 <dt><code id="vmax">vmax</code></dt>
 <dd>Equal to the larger of <code>vw</code> and <code>vh</code>.</dd>
</dl>

<h4 id="Absolute_length_units">Absolute length units</h4>

<p>Absolute length units represent a physical measurement when the physical properties of the output medium are known, such as for print layout. This is done by anchoring one of the units to a physical unit, and then defining the others relative to it. The anchor is done differently for low-resolution devices, such as screens, versus high-resolution devices, such as printers.</p>

<p>For low-dpi devices, the unit <code>px</code> represents the physical <em>reference pixel</em>; other units are defined relative to it. Thus, <code>1in</code> is defined as <code>96px</code>, which equals <code>72pt</code>. The consequence of this definition is that on such devices, dimensions described in inches (<code>in</code>), centimeters (<code>cm</code>), or millimeters (<code>mm</code>) don't necessary match the size of the physical unit with the same name.</p>

<p>For high-dpi devices, inches (<code>in</code>), centimeters (<code>cm</code>), and millimeters (<code>mm</code>) are the same as their physical counterparts. Therefore, the <code>px</code> unit is defined relative to them (1/96 of 1 inch).</p>

<div class="note">
<p><strong>Note:</strong> Many users increase their {{glossary("user agent")}}'s default font size to make text more legible. Absolute lengths can cause accessibility problems, since they are fixed and do not scale according to user settings. For this reason, prefer relative lengths (such as <code>em</code> or <code>rem</code>) when setting <code>font-size</code>.</p>
</div>

<dl>
 <dt><code id="px">px</code></dt>
 <dd>One pixel. For screen displays, it traditionally represents one device pixel (dot). However, for <em>printers</em> and <em>high-resolution screens</em>, one CSS pixel implies multiple device pixels. <code>1px</code> = 1/96th of <code>1in</code>.</dd>
 <dt><code id="cm">cm</code></dt>
 <dd>One centimeter. <code>1cm</code> = <code>96px/2.54</code>.</dd>
 <dt><code id="mm">mm</code></dt>
 <dd>One millimeter. <code>1mm</code> = 1/10th of <code>1cm</code>.</dd>
 <dt><code id="q">Q</code> {{experimental_inline}}</dt>
 <dd>One quarter of a millimeter. <code>1Q</code> = 1/40th of <code>1cm</code>.</dd>
 <dt><code id="in">in</code></dt>
 <dd>One inch. <code>1in</code> = <code>2.54cm</code> = <code>96px</code>.</dd>
 <dt><code id="pc">pc</code></dt>
 <dd>One pica. <code>1pc</code> = <code>12pt</code> = 1/6th of <code>1in</code>.</dd>
 <dt><code id="pt">pt</code></dt>
 <dd>One point. <code>1pt</code> = 1/72nd of <code>1in</code>.</dd>
 <dt><code id="mozmm">mozmm</code> {{non-standard_inline}}, removed in Firefox 59</dt>
 <dd>An experimental unit that attempts to render at exactly one millimeter regardless of the size or resolution of the display. This is rarely actually what you want, but may be useful in particular for mobile devices.</dd>
</dl>

<h2 id="Interpolation">Interpolation</h2>

<p>When animated, values of the <code>&lt;length&gt;</code> data type are interpolated as real, floating-point numbers. The interpolation happens on the calculated value. The speed of the interpolation is determined by the <a href="/en-US/docs/Web/CSS/single-transition-timing-function">timing function</a> associated with the animation.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Length_unit_comparison">Length unit comparison</h3>

<p>The following demo provides you with an input field in which you can enter a <code>&lt;length&gt;</code> value (e.g. <code>300px</code>, <code>50%</code>, <code>30vw</code>) to set the width of a result bar that will appear below it once you've pressed <kbd>Return</kbd>.</p>

<p>This allows you to compare and contrast the effect of different length units.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="outer"&gt;
  &lt;div class="input-container"&gt;
    &lt;label&gt;Enter width:&lt;/label&gt;
    &lt;input type="text" id="length"&gt;
  &lt;/div&gt;
  &lt;div class="inner"&gt;

  &lt;/div&gt;
&lt;/div&gt;
&lt;div class="results"&gt;
&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">html {
  font-family: sans-serif;
  font-weight: bold;
  box-sizing: border-box;
}

.outer {
  width: 100%;
  height: 50px;
  background-color: #eee;
  position: relative;
}

.inner {
  height: 50px;
  background-color: #999;
  box-shadow: inset 3px 3px 5px rgba(255,255,255,0.5),
              inset -3px -3px 5px rgba(0,0,0,0.5);
}

.result {
  height: 20px;
  background-color: #999;
  box-shadow: inset 3px 3px 5px rgba(255,255,255,0.5),
              inset -3px -3px 5px rgba(0,0,0,0.5);
  background-color: orange;
  display: flex;
  align-items: center;
  margin-top: 10px;
}

.result code {
  position: absolute;
  margin-left: 20px;
}

.results {
  margin-top: 10px;
}

.input-container {
  position: absolute;
  display: flex;
  justify-content: flex-start;
  align-items: center;
  height: 50px;
}

label {
  margin: 0 10px 0 20px;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">const inputDiv = document.querySelector('.inner');
const inputElem = document.querySelector('input');
const resultsDiv = document.querySelector('.results');

inputElem.addEventListener('change', () =&gt; {
  inputDiv.style.width = inputElem.value;

  const result = document.createElement('div');
  result.className = 'result';
  result.style.width = inputElem.value;
  result.innerHTML = `&lt;code&gt;width: ${inputElem.value}&lt;/code&gt;`;
  resultsDiv.appendChild(result);

  inputElem.value = '';
  inputElem.focus();
})</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Length_unit_comparison','100%', 700)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Values', '#lengths', '&lt;length&gt;')}}</td>
   <td>{{Spec2('CSS4 Values')}}</td>
   <td>Adds the <code>vi</code>, <code>vb</code>, <code>ic</code>, <code>lh</code>, and <code>rlh</code> units.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Values', '#lengths', '&lt;length&gt;')}}</td>
   <td>{{Spec2('CSS3 Values')}}</td>
   <td>Adds the <code>ch</code>, <code>rem</code>, <code>vw</code>, <code>vh</code>, <code>vmin</code>, <code>vmax</code>, and <code>Q</code> units.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'syndata.html#length-units', '&lt;length&gt;')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Explicit definition of the <code>em</code>, <code>pt</code>, <code>pc</code>, and <code>px</code> units.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#length-units', '&lt;length&gt;')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition. Implicit definition of the <code>em</code>, <code>pt</code>, <code>pc</code>, and <code>px</code> units.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.length")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Values_and_units">CSS values &amp; units tutorial</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Values_and_Units">CSS values &amp; units reference</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Box_Model">Box Model</a></li>
</ul>
